   10 REM ***************************************
   20 REM * ADFS Xfer                           *
   30 REM * BBC <-> PC Serial Transfer program  *
   40 REM * BBC End (Slave)                     *
   50 REM * (c) Jon Welch, 2006                 *
   60 REM * Based on code written by :          *
   70 REM * Mark de Weger, 1996-1997            *
   80 REM * Angus Duggan, 1999                  *
   90 REM ***************************************
  100 :
  110 REM *****************
  120 REM Main program
  130 REM *****************
  140 :
  150 REM Initialisation
  160 PROCreset
  170 REM Clear serial port buffers
  180 *FX 21,1
  190 *FX 21,2
  200 MODE 7
  210 ON ERROR PROCfatal_error
  220 PROCsetvars
  230 PROCassemble
  240 PROCinitconnection
  250 PROCmain
  260 END
  270 :
  280 REM Main procedure
  290 DEF PROCmain
  300 REM Switch RS423 Escape off
  310 *FX 181,1
  320 REM Switch RS423 Printer selection off
  330 *FX 5,0
  340 REM Switch RS423 Output off
  350 *FX 3,0
  360 REM Switch output to printer off
  370 VDU 3
  380 REPEAT
  390 REM Switch RS423 Output off
  400 *FX 3,0
  410 PROCstatus("waiting for command","",0)
  420 g$=GET$
  430 IF g$="B" THEN PROCbuffersize
  440 IF g$="S" THEN PROCsetspeed
  450 IF g$="*" THEN name$=FNread_string
  460 IF g$="*" THEN PROCoscli(name$)
  470 REM A: command to send ADFS disc sectors
  480 IF g$="A" THEN PROCsendADFStrack(0)
  490 REM a: command to write ADFS disc sectors
  500 IF g$="a" THEN PROCwriteADFStrack
  510 IF g$="c" THEN PROCsendADFStrack(1)
  520 UNTIL g$="Q"
  530 :
  540 REM Quit
  550 PROCreset
  560 REM Clear RS423 input buffer
  570 *FX 21,1
  580 IF g$="Q" THEN PROCstatus("quitting ADFS XFER","",0) ELSE PROCstatus("error at PC; quitting ADFS XFER","",0)
  590 END
  600 :
  610 REM ******************
  620 REM Oscli command
  630 REM ******************
  640 :
  650 REM Carry out * command
  660 DEF PROCoscli(oscli$)
  670 REM Switch output to printer on (*FX 3,3 doesn't work for *-commands)
  680 VDU 2
  690 REM Select RS423 for printer output
  700 *FX 5,2
  710 ON ERROR PROCallowed_error(err_txt$)
  720 OSCLI(oscli$)
  730 ON ERROR PROCfatal_error
  740 PRINT sync_text$
  750 REM Switch output to printer off
  760 VDU 3
  770 REM Deselect RS423 for printer output
  780 *FX 5,0
  790 ENDPROC
  800 :
  810 REM ****************************
  820 REM 1770 read ADFS track
  830 REM ****************************
  840 :
  850 REM Send read track and perform CRC
  860 DEF PROCsendADFStrack(crc_flag%)
  870 pblock%?0=0
  880 pblock%!1=buffer%
  890 pblock%?5=8
  900 pblock%?6=FNread_integer*32
  910 S%=FNread_integer
  920 pblock%?6=pblock%?6 OR (S% DIV 65536) MOD 32
  930 pblock%?7=(S% DIV 256) MOD 256
  940 pblock%?8=S% MOD 256
  950 N%=FNread_integer
  960 pblock%?9=N%
  970 pblock%?10=0
  980 pblock%!11=0
  990 !crc%=0
 1000 IF crc_flag% = 0 PROCstatus("Sending drive "+STR$(pblock%?6 DIV 32),"Sectors "+STR$(S%)+" to "+STR$(S%+N%-1),0)
 1010 IF crc_flag% = 1 PROCstatus("CRCing drive "+STR$(pblock%?6 DIV 32),"Sectors "+STR$(S%)+" to "+STR$(S%+N%-1),0)
 1020 REM Switch on RS423 output
 1030 *FX3,3
 1040 ON ERROR PROCallowed_error("")
 1050 CALL readADFStrack%
 1060 IF ?pblock%<>0 THEN PRINT err_txt2$:GOTO1090
 1070 IF crc_flag% = 0 CALLsendtrack% ELSE CALLcrctrack%
 1080 PROCwrite_integer(!crc%)
 1090 ON ERROR PROCfatal_error
 1100 REM Switch off RS423 output
 1110 *FX3,0
 1120 ENDPROC
 1130 :
 1140 DEF PROCsetspeed
 1150 S%=FNread_integer
 1160 IF S%=1200 THEN X%=4
 1170 IF S%=2400 THEN X%=5
 1180 IF S%=4800 THEN X%=6
 1190 IF S%=9600 THEN X%=7
 1200 IF S%=19200 THEN X%=8
 1210 A%=7
 1220 CALL osbyte%
 1230 A%=8
 1240 CALL osbyte%
 1250 IF INKEY(100)
 1260 *FX 3,3
 1270 PRINT sync_text$
 1280 *FX 3,0
 1290 ENDPROC
 1300 :
 1310 REM ****************************
 1320 REM 1770 write ADFS track
 1330 REM ****************************
 1340 :
 1350 REM Write track and perform CRC
 1360 DEF PROCwriteADFStrack
 1370 pblock%?0=0
 1380 pblock%!1=buffer%
 1390 pblock%?5=10
 1400 pblock%?6=FNread_integer*32
 1410 S%=FNread_integer
 1420 pblock%?6=pblock%?6 OR (S% DIV 65536) MOD 32
 1430 pblock%?7=(S% DIV 256) MOD 256
 1440 pblock%?8=S% MOD 256
 1450 N%=FNread_integer
 1460 pblock%?9=0
 1470 pblock%?10=0
 1480 pblock%!11=N% * 256
 1490 !crc%=0
 1500 PROCstatus("Writing drive "+STR$(pblock%?6 DIV 32),"Sectors "+STR$(S%)+" to "+STR$(S%+N%-1),0)
 1510 ON ERROR PROCallowed_error("")
 1520 REM Print string to show ready to receive track
 1530 *FX 3,3
 1540 PRINT sync_text$
 1550 *FX 3,0
 1560 CALL writeADFStrack%
 1570 REM Send crc to pc
 1580 *FX 3,3
 1590 IF ?pblock%<>0 THEN PRINT err_txt2$ ELSE PROCwrite_integer(!crc%)
 1600 ON ERROR PROCfatal_error
 1610 REM Switch off RS423 output
 1620 *FX3,0
 1630 ENDPROC
 1640 :
 1650 DEF PROCbuffersize
 1660 *FX 3,3
 1670 PROCwrite_integer(bufsize%)
 1680 ON ERROR PROCfatal_error
 1690 *FX3,0
 1700 ENDPROC
 1710 :
 1720 REM ****************************
 1730 REM Initialisation/error/status
 1740 REM ****************************
 1750 :
 1760 REM Initialise and check connection
 1770 DEF PROCinitconnection
 1780 PROCstatus("Waiting for connection","",0)
 1790 *FX 7,4
 1800 *FX 8,4
 1810 REM Receive from RS423
 1820 *FX 2,1
 1830 ENDPROC
 1840 :
 1850 REM Initialise variables
 1860 DEF PROCsetvars
 1870 DIM pblock% &11
 1880 DIM nblock% 256
 1890 osbyte%=&FFF4
 1900 osword%=&FFF1
 1910 oscli%=&FFF7
 1920 osfile%=&FFDD
 1930 osgbpb%=&FFD1
 1940 oswrch%=&FFEE
 1950 sync_text$="-----BBC-----PC-----"
 1960 err_txt$="-----BBCerror1-----PC-----"
 1970 err_txt2$=CHR$(27)+CHR$(2)
 1980 @%=&90A
 1990 REM Variables for mc
 2000 crc%=&70
 2010 filelength%=&74
 2020 bufptr%=&78
 2030 buflen%=&7A
 2040 bufidx%=&7B
 2050 sp%=&82
 2060 sl%=&84
 2070 ch%=&88
 2080 ty%=&89
 2090 ENDPROC
 2100 :
 2110 REM Print status of connection
 2120 DEF PROCstatus(status$,file$,length%)
 2130 CLS
 2140 PRINT CHR$141;"ADFS XFER Ver 1.7.2"
 2150 PRINT CHR$141;"ADFS XFER Ver 1.7.2"
 2160 PRINT
 2170 PRINT ""
 2180 PRINT "Status: ";status$
 2190 IF file$<>"" THEN PRINT "        ";file$
 2200 IF length%<>0 THEN PRINT "  File length: ";STR$(length%)
 2210 PRINT ""
 2220 ENDPROC
 2230 :
 2240 REM Reset RS423
 2250 DEF PROCreset
 2260 ON ERROR OFF
 2270 REM Close serial port and reselect keyboard input
 2280 *FX 2,0
 2290 REM Flush serial port input buffer
 2300 *FX 21,1
 2310 REM Reselect VDU output
 2320 *FX 3,0
 2330 REM Deselect RS423 as printer destination
 2340 *FX 5,0
 2350 REM Switch printer output off
 2360 VDU 3
 2370 REM Close remaining open files
 2380 PRINT ""
 2390 ENDPROC
 2400 :
 2410 REM Fatal error
 2420 DEF PROCfatal_error
 2430 PROCreset
 2440 REPORT
 2450 PRINT " at line ";ERL
 2460 END
 2470 ENDPROC
 2480 :
 2490 REM ********************
 2500 REM RS423 Utilities
 2510 REM ********************
 2520 :
 2530 REM Read string
 2540 DEF FNread_string
 2550 LOCAL string$,g$
 2560 string$=""
 2570 REPEAT
 2580 g$=GET$
 2590 REM IF ASC(g$)<32 THEN PRINT "~ ";~ASC(g$);" "; ELSE PRINT g$;" ";~ASC(g$);" ";
 2600 IF g$<>CHR$(13) THEN string$=string$+g$
 2610 UNTIL g$=CHR$(13)
 2620 PRINT 'string$
 2630 =string$
 2640 :
 2650 REM Read integer
 2660 DEF FNread_integer
 2670 LOCAL s$
 2680 s$=FNread_string
 2690 =VAL(s$)
 2700 :
 2710 REM Write integer
 2720 DEF PROCwrite_integer(i%)
 2730 LOCAL s$
 2740 s$=STR$(i%)
 2750 PRINT s$
 2760 ENDPROC
 2770 :
 2780 REM Error to be trapped
 2790 DEF PROCallowed_error(pc$)
 2800 ON ERROR PROCfatal_error
 2810 REM Close open files
 2820 REM Switch off RS423 output
 2830 *FX 3,0
 2840 REM De-select RS423 printer
 2850 *FX 5,0
 2860 REM Switch output to printer off
 2870 VDU 3
 2880 REM Switch RS423 Escape off
 2890 *FX 181,1
 2900 PROCstatus("error, waiting for PC to respond","",0)
 2910 REM Switch on RS423 output
 2920 *FX 3,3
 2930 REM Print string to tell PC of error
 2940 IF pc$<>"" THEN PRINT pc$
 2950 REM Wait for pc to respond acknowledgement of error
 2960 pc$=""
 2970 REPEAT
 2980 g$=GET$
 2990 IF g$<>"" THEN pc$=pc$+g$ ELSE pc$=""
 3000 IF LEN(pc$)>LEN(err_txt$) THEN pc$=RIGHT$(pc$,LEN(pc$)-1)
 3010 UNTIL pc$=err_txt$
 3020 REM Send error to PC
 3030 REPORT
 3040 PRINT
 3050 REM Switch off RS423 output
 3060 *FX 3,0
 3070 PROCmain
 3080 :
 3090 REM ***********************
 3100 REM Machine code generation
 3110 REM ***********************
 3120 :
 3130 DEF PROCassemble
 3140 DIM mc% 400
 3150 DIM top% -1
 3160 bufsize% = 4096 * ((HIMEM - top% - 256) DIV 4096)
 3170 DIM buffer% bufsize%
 3180 esc=27
 3190 FOR opt%=0 TO 2 STEP 2
 3200 P%=mc%
 3210 [
 3220 OPT opt%
 3230 \ Merge accumulator into CRC. Invalidates A,X,P
 3240 .crccalc
 3250 PHA
 3260 EOR crc%+1
 3270 STA crc%+1
 3280 LDX #8
 3290 .crcloop
 3300 LDA crc%+1
 3310 ROL A
 3320 BCC crcclear
 3330 LDA crc%
 3340 EOR #&57
 3350 STA crc%
 3360 .crcclear
 3370 ROL crc%
 3380 ROL crc%+1
 3390 DEX
 3400 BNE crcloop
 3410 PLA
 3420 RTS
 3430 \
 3440 .crctrack%
 3450 \ CRC track
 3460 LDA #buffer% MOD 256
 3470 STA sp%
 3480 LDA #buffer% DIV 256
 3490 STA sp%+1
 3500 LDA buflen%
 3510 STA sl%
 3520 LDY #0
 3530 .docrc
 3540 LDA(sp%),Y:JSR crccalc
 3550 INY:BNE docrc
 3560 INC sp%+1:DEC sl%:BNE docrc
 3570 RTS
 3580 \
 3590 \ 1770 command read ADFS track of data into buffer
 3600 .readADFStrack%
 3610 LDA pblock%+9
 3620 STA buflen%
 3630 LDX #pblock% MOD 256
 3640 LDY #pblock% DIV 256
 3650 LDA #&72
 3660 JSR osword%
 3670 RTS
 3680 .sendtrack%
 3690 \ Compress track and send
 3700 LDA #buffer% MOD 256
 3710 STA sp%
 3720 LDA #buffer% DIV 256
 3730 STA sp%+1
 3740 LDA buflen%
 3750 STA sl% + 1
 3760 LDA #0
 3770 STA sl%
 3780 JSR compress
 3790 RTS
 3800 \
 3810 .put
 3820 CPY #4:BCC P%+6:JSR multi:RTS
 3830 CPY #1:BCC P%+5:JSR single
 3840 CPY #2:BCC P%+5:JSR single
 3850 CPY #3:BCC P%+5:JSR single
 3860 RTS
 3870 .multi
 3880 LDA #esc:JSR single2
 3890 TYA:JSR single1
 3900 LDA ch%:JSR single1
 3910 RTS
 3920 .single2
 3930 JSR single1
 3940 LDA #0:JMP single1
 3950 .single
 3960 CMP #esc:BNE single1
 3970 JSR single1
 3980 PHA:LDA #1:JSR single1:PLA:RTS
 3990 .single1
 4000 STY ty%
 4010 JSR oswrch%:JSR crccalc
 4020 LDY ty%:RTS
 4030 .compress
 4040 LDA sl%:ORA sl%+1:BEQ compress5
 4050 LDY #0
 4060 LDA(sp%),Y:STA ch%:INY
 4070 DEC sl%:LDA sl%:CMP#255:BNE P%+4:DEC sl%+1
 4080 .compress2
 4090 LDA sl%:ORA sl%+1:BEQ compress4
 4100 LDA(sp%),Y:CMP ch%:BNE compress3
 4110 INY
 4120 DEC sl%:LDA sl%:CMP#255:BNE P%+4:DEC sl%+1
 4130 CPY #255:BNE compress2
 4140 .compress3
 4150 LDA ch%
 4160 JSR put
 4170 CLC:TYA:ADC sp%:STA sp%:BCC P%+4:INC sp%+1
 4180 JMP compress
 4190 .compress4
 4200 LDA ch%
 4210 JSR put
 4220 CLC:TYA:ADC sp%:STA sp%:BCC P%+4:INC sp%+1
 4230 .compress5
 4240 LDA #esc:JSR oswrch%:JSR crccalc
 4250 LDA #3:JSR oswrch%:JSR crccalc
 4260 RTS
 4270 \
 4280 \ Receive an ADFS track and write to disc
 4290 .writeADFStrack%
 4300 JSR rcvtrack%
 4310 BCCP%+3:RTS
 4320 LDX #pblock% MOD 256
 4330 LDY #pblock% DIV 256
 4340 LDA #&72
 4350 JSR osword%
 4360 RTS
 4370 \
 4380 \ Receive a track
 4390 .rcvtrack%
 4400 LDA #buffer% MOD 256:STA bufptr%
 4410 LDA #buffer% DIV 256:STA bufptr%+1
 4420 .rx1
 4430 JSR getchar:CMP#esc:BEQ rx2:JSR store:JMP rx1
 4440 .rx2
 4450 JSR getchar
 4460 CMP #0:BNE rx3
 4470 JSR getchar:STA ty%
 4480 JSR getchar:LDX ty%
 4490 JSR store:DEX:BNE P% - 4:JMP rx1
 4500 .rx3
 4510 CMP #1:BEQ rx4
 4520 \ 2 = abort so sec
 4530 \ 3 = done so clc
 4540 CMP#2:BNEP%+4:SEC:RTS
 4550 CLC:RTS
 4560 .rx4
 4570 LDA #esc:JSR store:JMP rx1
 4580 .store
 4590 LDY #0:STA (bufptr%),Y
 4600 INC bufptr%:BNE P%+4:INC bufptr%+1
 4610 RTS
 4620 .getchar
 4630 LDA #145:LDX #1:JSR osbyte%:BCS getchar:TYA:JSR crccalc:RTS
 4640 ]
 4650 NEXT
 4660 ENDPROC

